/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.client;

import org.openiec61850.common.ServiceError;

/**
 * @author Stefan Feuerhahn
 * @author Tobias Weidelt
 */
public interface ClientScsmSAP {

	/**
	 * The Associate service which tries to connect and build an association to
	 * an IEC 61850 server.
	 * 
	 * @param serverAccessPointReference
	 *            the syntax of this parameter is mapping specific
	 * @param authenticationParameter
	 *            the syntax of this parameter is mapping specific
	 * @param connectTimeout
	 *            the time in milliseconds after which the TCP/IP connection
	 *            attempt shall be aborted and a service error is thrown
	 * @throws ServiceError
	 * @throws IllegalArgumentException
	 */
	ClientACSI associate(String serverAccessPointReference, String authenticationParameter, int connectTimeout)
			throws ServiceError, IllegalArgumentException;

}
