/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.common.model;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.openiec61850.common.model.datypes.DAType;

abstract public class BasicDataAttribute extends ModelNode {

	// /** value object. Type is indicated by "type" attribute */
	// private Object value = null;

	/** attribute value type */
	protected DAType basicType = null;

	/** short address, can be used by SCSM and for local data mapping */
	protected String sAddr = null;

	protected boolean dchg;
	protected boolean qchg;
	protected boolean dupd;

	// public BasicDataAttribute(ObjectReference objectReference,
	// FunctionalConstraint fc, BasicType type, String sAddr,
	// String enumRef, boolean dchg, boolean qchg, boolean dupd) {
	// this.objectReference = objectReference;
	// objectType = ObjectType.BASIC_DATA_ATTRIBUTE;
	// this.fc = fc;
	// this.basicType = type;
	// this.sAddr = sAddr;
	// this.enumRef = enumRef;
	// this.dchg = dchg;
	// this.qchg = qchg;
	// this.dupd = dupd;
	// }

	// public Object getValue();
	// {
	// return value;
	// }
	
	public abstract Object getValue();
	
	public boolean getDchg(){
		return dchg;
	}
	
	public boolean getDupd(){
		return dupd;
	}
	
	public boolean getQchg(){
		return dupd;
	}

	public DAType getBasicType() {
		return basicType;
	}

	public String getSAddr() {
		return sAddr;
	}

	@Override
	public ModelNode getChild(String childName, FunctionalConstraint fc) {
		return null;
	}

	@Override
	public ModelNode getChild(String childName) {
		return null;
	}

	@Override
	public Collection<ModelNode> getChildren() {
		return null;
	}

	// @Override
	// public String toString() {
	// return getReference().toString() + " [" + fc + "], value = " + value;
	// }

	// @Override
	// public BasicDataAttribute copy() {
	// BasicDataAttribute copy = new BasicDataAttribute(this.getReference(),
	// this.fc, this.basicType, this.sAddr,
	// this.enumRef, dchg, qchg, dupd);
	//
	// // TODO set value
	// // only create a new Object if the Object is not immutable
	//
	// return copy;
	// }

	public Iterator<ModelNode> iterator() {
		return Collections.<ModelNode> emptyList().iterator();
	}

	abstract public void setDefault();

	// switch (basicType) {
	// case BOOLEAN:
	// value = new Boolean(false);
	// break;
	// case INT8:
	// case INT8U:
	// value = new Byte((byte) 0);
	// break;
	// case INT16:
	// case INT16U:
	// value = new Short((short) 0);
	// break;
	// case INT32:
	// case INT32U:
	// value = new Integer((short) 0);
	// break;
	// case INT64:
	// value = new Long(0);
	// break;
	// case FLOAT32:
	// value = new Float(0);
	// break;
	// case ENUMERATED:
	// value = new Integer(0);
	// break;
	// case TIMESTAMP:
	// value = new Timestamp();
	// break;
	// case QUALITY:
	// value = new Quality();
	// break;
	// case OCTET_STRING_64:
	// value = new byte[0];
	// break;
	// case VISIBLE_STRING_255:
	// case VISIBLE_STRING_129:
	// case VISIBLE_STRING_64:
	// case VISIBLE_STRING_32:
	// case UNICODE_STRING_255:
	// value = "";
	// break;
	// }
	// }

	// public void setValue(Object value) {
	// this.value = value;
	// }

	@Override
	public List<BasicDataAttribute> getBasicDataAttributes() {
		List<BasicDataAttribute> subBasicDataAttributes = new LinkedList<BasicDataAttribute>();
		subBasicDataAttributes.add(this);
		return subBasicDataAttributes;
	}

}
