/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.openiec61850.common.model.datypes;

import org.openiec61850.common.model.BasicDataAttribute;

/**
 * This Enumeration includes all possible Types for IEC 61850 leave nodes (
 * {@link BasicDataAttribute}). This includes BasicTypes and CommonACSITypes as
 * defined in part 7-2. In the description of each Enum Constant is the Java
 * Class that represents the value in the respective {@link BasicDataAttribute}.
 * 
 * @author Stefan Feuerhahn
 * 
 */
public enum DAType {
	/** java.lang.Boolean */
	BOOLEAN,
	/** java.lang.Byte */
	INT8,
	/** java.lang.Short */
	INT16,
	/** java.lang.Integer */
	INT32,
	/** java.lang.Long */
	INT64,
	/** java.lang.Byte */
	INT8U,
	/** java.lang.Short */
	INT16U,
	// not used because it is only used by TimeStamp which is a BasicType
	// itself:
	// INT24U,
	/** java.lang.Integer */
	INT32U,
	/** java.lang.Float */
	FLOAT32,
	// is not being used and therefore not supported:
	// FLOAT64,
	/** java.lang.Float */
	ENUMERATED,

	OCTET_STRING_64,
	
	OCTET_STRING_6,

	VISIBLE_STRING_32,

	VISIBLE_STRING_64,

	VISIBLE_STRING_129,

	VISIBLE_STRING_255,

	UNICODE_STRING_255,

	TIMESTAMP, QUALITY,

//	DBPOS,
//
//	TCMD,
	
	CODEDENUM,

	GENERIC_BITSTRING;
}
