package org.openiec61850.common.model.datypes.basic;

import org.openiec61850.common.ServiceError;
import org.openiec61850.common.model.BasicDataAttribute;
import org.openiec61850.common.model.FunctionalConstraint;
import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.DAType;

public class CodedEnum extends BasicDataAttribute{
	byte[] value; 
	
	public CodedEnum (ObjectReference objectReference, FunctionalConstraint fc, String sAddr, byte[] value, boolean dchg, boolean dupd){
		this.objectReference = objectReference;
		this.fc = fc;
		this.basicType = DAType.CODEDENUM;
		this.sAddr = sAddr;
		this.value = value;
		this.dchg = dchg;
		this.dupd = dupd;
	}
	
	public byte[] getValue(){
		return value;
	}
	
	public void setValue(byte[] value) throws ServiceError{
		this.value = value;
	}	
	
	
	@Override
	public void setDefault() {
		value = new byte[1]; 
	}

	@Override
	public CodedEnum copy() {
		return new CodedEnum(this.objectReference, this.fc, this.sAddr, value, this.dchg, this.dupd);
	}
}
