/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.openiec61850.common.model.datypes.basic;

import org.openiec61850.common.model.BasicDataAttribute;
import org.openiec61850.common.model.FunctionalConstraint;
import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.DAType;

public class Enumerated extends BasicDataAttribute{
	/** reference to enum type if type is "Enum" */
	private String enumRef = null;
	
	private Integer value;
	
	public Enumerated(ObjectReference objectReference, FunctionalConstraint fc, String sAddr, String enumRef, Integer value, boolean dchg, boolean dupd){
		this.objectReference = objectReference;
		this.fc = fc;
		this.basicType = DAType.ENUMERATED;
		this.sAddr = sAddr;
		this.enumRef = enumRef;
		this.value = value;
		this.dchg = dchg;
		this.dupd = dupd;
	}
	
	public Integer getValue(){
		return value;
	}
	
	public void setValue(Integer value){
		this.value = value;
	}
	
	public String getEnumRef(){
		return enumRef;
	}	
	
	
	@Override
	public void setDefault() {
		value = 0;
	}

	@Override
	public Enumerated copy() {
		// TODO Auto-generated method stub
		return new Enumerated(this.objectReference, this.fc, this.sAddr, this.enumRef, value, this.dchg, this.dupd);
		
//		return null;
	}
	

}
