/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.openiec61850.common.model.datypes.basic;

import org.openiec61850.common.model.BasicDataAttribute;
import org.openiec61850.common.model.FunctionalConstraint;
import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.DAType;

public class INT32 extends BasicDataAttribute {

	private Integer value;
	
	public INT32(ObjectReference objectReference, FunctionalConstraint fc, String sAddr, Integer value, boolean dchg, boolean dupd){
		this.objectReference = objectReference;
		this.fc = fc;
		this.sAddr = sAddr;
		this.basicType = DAType.INT32;
		this.value = value;
		this.dchg = dchg;
		this.dupd = dupd;
	}

	public void setValue(Integer value){
		this.value = value;
	}
	
	public Integer getValue(){
		return value;
	}	
	
	
	@Override
	public void setDefault() {
		value = 0;
	}

	@Override
	public INT32 copy() {
		// TODO Auto-generated method stub
		return new INT32(this.objectReference, this.fc, this.sAddr, value,  this.dchg, this.dupd);
		
//		return null;
	}

}
