package org.openiec61850.common.model.datypes.basic;

import org.openiec61850.common.ServiceError;
import org.openiec61850.common.model.BasicDataAttribute;
import org.openiec61850.common.model.FunctionalConstraint;
import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.DAType;

public class OCTET_STRING_64 extends BasicDataAttribute {

	private byte[] value;
	
	public OCTET_STRING_64(ObjectReference objectReference, FunctionalConstraint fc, String sAddr, byte[] value, boolean dchg, boolean dupd){
		this.objectReference = objectReference;
		this.fc = fc;
		this.basicType = DAType.OCTET_STRING_64;
		this.sAddr = sAddr;
		this.value = value;
		this.dchg = dchg;
		this.dupd = dupd;
	}
	
	public byte[] getValue(){
		return value;
	}
	
	public void setValue(byte[] value) throws ServiceError {
		if (value.length > 64){ 
			throw new ServiceError(ServiceError.PARAMETER_VALUE_INAPPROPRIATE);
		}
		
		this.value = value;
	}	
	
	
	@Override
	public void setDefault() {
		value = new byte[0];
	}
	
	@Override
	public OCTET_STRING_64 copy() {
		// TODO Auto-generated method stub
		return new OCTET_STRING_64(this.objectReference, this.fc, this.sAddr, value, this.dchg, this.dupd);
		
//		return null;
	}
	
}
