/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.common.model.log;

import java.util.ArrayList;
import java.util.List;

import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.commonacsi.Timestamp;

public class Log {

	private String logName;
	private ObjectReference logRef;
	private Timestamp oldEntrTm;
	private Timestamp newEntrTm;
	private long oldEntr;
	private long newEntr;
	private final List<LogEntry> entries = new ArrayList<LogEntry>();

	public String getLogName() {
		return logName;
	}

	public void setLogName(String logName) {
		this.logName = logName;
	}

	public ObjectReference getLogRef() {
		return logRef;
	}

	public void setLogRef(ObjectReference logRef) {
		this.logRef = logRef;
	}

	public Timestamp getOldEntrTm() {
		return oldEntrTm;
	}

	public void setOldEntrTm(Timestamp oldEntrTm) {
		this.oldEntrTm = oldEntrTm;
	}

	public Timestamp getNewEntrTm() {
		return newEntrTm;
	}

	public void setNewEntrTm(Timestamp newEntrTm) {
		this.newEntrTm = newEntrTm;
	}

	public long getOldEntr() {
		return oldEntr;
	}

	public void setOldEntr(long oldEntr) {
		this.oldEntr = oldEntr;
	}

	public long getNewEntr() {
		return newEntr;
	}

	public void setNewEntr(long newEntr) {
		this.newEntr = newEntr;
	}

	public List<LogEntry> getEntries() {
		return entries;
	}

}
