/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.common.model.log;

import java.util.ArrayList;
import java.util.List;

import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.commonacsi.Timestamp;

public class LogEntry {

	private ObjectReference logRef;
	private Timestamp entryTime;
	private long entryId;
	private List<LogEntryData> entryData = new ArrayList<LogEntryData>();

	public ObjectReference getLogRef() {
		return logRef;
	}

	public void setLogRef(ObjectReference logRef) {
		this.logRef = logRef;
	}

	public Timestamp getEntryTime() {
		return entryTime;
	}

	public void setEntryTime(Timestamp entryTime) {
		this.entryTime = entryTime;
	}

	public long getEntryId() {
		return entryId;
	}

	public void setEntryId(long entryId) {
		this.entryId = entryId;
	}

	public List<LogEntryData> getEntryData() {
		return entryData;
	}

	public void addLogEntryData(LogEntryData led) {
		getEntryData().add(led);
		led.setLogEntry(this);
	}

	public void setEntryData(List<LogEntryData> entryData) {
		this.entryData = entryData;
	}

}
