/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.common.model.report;

import java.io.Serializable;


/**
 * Saves the next sequence number to be used for a report to be send to a client
 * 
 * @author bertram
 */
public class ClientReportState implements Serializable {

	private static final long serialVersionUID = -6942618743395537728L;
	/**
	 * see {@link Report#sqNum}
	 */
	private int sqNum = 0;
	private String reportId;
	private String clientId;
	private long reportEntryId;

	public ClientReportState(String reportId, String clientId) {
		this.clientId = clientId;
		this.reportId = reportId;
		this.setSqNum(0);
	}

	public boolean matches(String reportId, String clientId) {
		return this.reportId.equals(reportId) && this.clientId.equals(clientId);
	}

	public void setSqNum(int sqNum) {
		this.sqNum = sqNum;
	}

	public int getSqNum() {
		return sqNum;
	}

	public String getReportId() {
		return reportId;
	}

	public void setReportId(String reportId) {
		this.reportId = reportId;
	}

	public String getClientId() {
		return clientId;
	}

	public void setClientId(String clientId) {
		this.clientId = clientId;
	}

	public long getReportEntryId() {
		return reportEntryId;
	}

	public void setReportEntryId(long reportEntryId) {
		this.reportEntryId = reportEntryId;
	}

}