/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.server;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class IED {

	private final Map<String, AccessPoint> accessPoints;
	private final ServiceSupport serviceSupport;

	public IED(List<AccessPoint> accessPoints, ServiceSupport serviceSupport) {
		this.accessPoints = new LinkedHashMap<String, AccessPoint>();
		for (AccessPoint accessPoint : accessPoints) {
			this.accessPoints.put(accessPoint.getName(), accessPoint);
		}
		this.serviceSupport = serviceSupport;
	}

	public List<AccessPoint> getAccessPoints() {
		return new ArrayList<AccessPoint>(accessPoints.values());
	}

	public AccessPoint getAccessPoint(String accessPointName) {
		return accessPoints.get(accessPointName);
	}

	public ServiceSupport getServiceSupport() {
		return serviceSupport;
	}

}
