/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openiec61850.server.scl;

import java.util.Vector;

public class TypeDefinitions {
	private final Vector<LNodeType> lnodeTypes = new Vector<LNodeType>();
	private final Vector<DOType> doTypes = new Vector<DOType>();
	private final Vector<DAType> daTypes = new Vector<DAType>();
	private final Vector<EnumType> enumTypes = new Vector<EnumType>();

	public TypeDefinitions() {
	}

	void putLNodeType(LNodeType lnodeType) {
		lnodeTypes.add(lnodeType);
	}

	void putDOType(DOType doType) {
		doTypes.add(doType);
	}

	void putDAType(DAType daType) {
		daTypes.add(daType);
	}

	void putEnumType(EnumType enumType) {
		enumTypes.add(enumType);
	}

	public DAType getDAType(String daType) {
		for (DAType datype : daTypes) {
			if (datype.getId().equals(daType)) {
				return datype;
			}
		}

		return null;
	}

	public DOType getDOType(String doType) {
		for (DOType dotype : doTypes) {
			if (dotype.getId().equals(doType)) {
				return dotype;
			}
		}

		return null;
	}

	public LNodeType getLNodeType(String lnType) {

		for (LNodeType ntype : lnodeTypes) {
			if (ntype.getId().equals(lnType)) {
				return ntype;
			}
		}

		return null;
	}

	public EnumType getEnumType(String enumTypeRef) {
		for (EnumType enumType : enumTypes) {
			if (enumType.getId().equals(enumTypeRef)) {
				return enumType;
			}
		}

		return null;
	}

}
