/**
 * This class file was automatically generated by jASN1 (http://www.openmuc.org)
 */

package org.openiec61850.jmms.mms.asn1;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.LinkedList;
import org.openmuc.jasn1.ber.*;
import org.openmuc.jasn1.ber.types.*;
import org.openmuc.jasn1.ber.types.string.*;

public class AlternateAccess {

public static class SubChoice {

	public byte[] code = null;
	public static class SubSeq_named {

		public final static BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS, BerIdentifier.CONSTRUCTED, 16);
		protected BerIdentifier id;

		public byte[] code = null;
		public BerVisibleString componentName = null;

		public AlternateAccessSelection accesst = null;

		public SubSeq_named() {
			id = identifier;
		}

		public SubSeq_named(byte[] code) {
			id = identifier;
			this.code = code;
		}

		public SubSeq_named(BerVisibleString componentName, AlternateAccessSelection accesst) {
			id = identifier;
			this.componentName = componentName;
			this.accesst = accesst;
		}

		public int encode(BerByteArrayOutputStream berOStream, boolean explicit) throws IOException {

			int codeLength;

			if (code != null) {
				codeLength = code.length;
				for (int i = code.length - 1; i >= 0; i--) {
					berOStream.write(code[i]);
				}
			}
			else {
				codeLength = 0;
				codeLength += accesst.encode(berOStream, true);
				
				codeLength += componentName.encode(berOStream, false);
				codeLength += (new BerIdentifier(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)).encode(berOStream);
				
				codeLength += BerLength.encodeLength(berOStream, codeLength);
			}

			if (explicit) {
				codeLength += id.encode(berOStream);
			}

			return codeLength;

		}

		public int decode(InputStream iStream, boolean explicit) throws IOException {
			int codeLength = 0;
			int subCodeLength = 0;
			BerIdentifier berIdentifier = new BerIdentifier();
			boolean decodedIdentifier = false;

			if (explicit) {
				codeLength += id.decodeAndCheck(iStream);
			}

			BerLength length = new BerLength();
			codeLength += length.decode(iStream);

			if (subCodeLength < length.val) {
				if (decodedIdentifier == false) {
					subCodeLength += berIdentifier.decode(iStream);
					decodedIdentifier = true;
				}
				if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 0)) {
					componentName = new BerVisibleString();
					subCodeLength += componentName.decode(iStream, false);
					decodedIdentifier = false;
				}
				else {
					throw new IOException("Identifier does not macht required sequence element identifer.");
				}
			}
			if (subCodeLength < length.val) {
				if (decodedIdentifier == false) {
					subCodeLength += berIdentifier.decode(iStream);
					decodedIdentifier = true;
				}
				accesst = new AlternateAccessSelection();
				subCodeLength += accesst.decode(iStream, berIdentifier);
				decodedIdentifier = false;
			}
			if (subCodeLength != length.val) {
				throw new IOException("Decoded sequence has wrong length tag");

			}
			codeLength += subCodeLength;

			return codeLength;
		}

		public void encodeAndSave(int encodingSizeGuess) throws IOException {
			BerByteArrayOutputStream berOStream = new BerByteArrayOutputStream(encodingSizeGuess);
			encode(berOStream, false);
			code = berOStream.getArray();
		}
	}

	public BerVisibleString component = null;

	public BerInteger index = null;

	public IndexRangeSeq indexRange = null;

	public BerNull allElements = null;

	public SubSeq_named named = null;

	public SubChoice() {
	}

	public SubChoice(byte[] code) {
		this.code = code;
	}

	public SubChoice(BerVisibleString component, BerInteger index, IndexRangeSeq indexRange, BerNull allElements, SubSeq_named named) {
		this.component = component;
		this.index = index;
		this.indexRange = indexRange;
		this.allElements = allElements;
		this.named = named;
	}

	public int encode(BerByteArrayOutputStream berOStream, boolean explicit) throws IOException {
		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				berOStream.write(code[i]);
			}
			return code.length;

		}
		int codeLength = 0;
		if (named != null) {
			codeLength += named.encode(berOStream, false);
			codeLength += (new BerIdentifier(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 5)).encode(berOStream);
			return codeLength;

		}
		
		if (allElements != null) {
			codeLength += allElements.encode(berOStream, false);
			codeLength += (new BerIdentifier(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 4)).encode(berOStream);
			return codeLength;

		}
		
		if (indexRange != null) {
			codeLength += indexRange.encode(berOStream, false);
			codeLength += (new BerIdentifier(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 3)).encode(berOStream);
			return codeLength;

		}
		
		if (index != null) {
			codeLength += index.encode(berOStream, false);
			codeLength += (new BerIdentifier(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 2)).encode(berOStream);
			return codeLength;

		}
		
		if (component != null) {
			codeLength += component.encode(berOStream, false);
			codeLength += (new BerIdentifier(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 1)).encode(berOStream);
			return codeLength;

		}
		
		throw new IOException("Error encoding BerChoice: No item in choice was selected.");
	}

	public int decode(InputStream iStream, BerIdentifier berIdentifier) throws IOException {
		int codeLength = 0;
		if (berIdentifier == null) {
			berIdentifier = new BerIdentifier();
			codeLength += berIdentifier.decode(iStream);
		}
		if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 1)) {
			component = new BerVisibleString();
			codeLength += component.decode(iStream, false);
			return codeLength;
		}
		if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 2)) {
			index = new BerInteger();
			codeLength += index.decode(iStream, false);
			return codeLength;
		}
		if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 3)) {
			indexRange = new IndexRangeSeq();
			codeLength += indexRange.decode(iStream, false);
			return codeLength;
		}
		if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.PRIMITIVE, 4)) {
			allElements = new BerNull();
			codeLength += allElements.decode(iStream, false);
			return codeLength;
		}
		if (berIdentifier.equals(BerIdentifier.CONTEXT_CLASS, BerIdentifier.CONSTRUCTED, 5)) {
			named = new SubSeq_named();
			codeLength += named.decode(iStream, false);
			return codeLength;
		}
		throw new IOException("Error decoding BerChoice: Identifier matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		BerByteArrayOutputStream berOStream = new BerByteArrayOutputStream(encodingSizeGuess);
		encode(berOStream, false);
		code = berOStream.getArray();
	}
}

public final static BerIdentifier identifier = new BerIdentifier(BerIdentifier.UNIVERSAL_CLASS, BerIdentifier.CONSTRUCTED, 16);
protected BerIdentifier id;

public byte[] code = null;
public List<SubChoice> seqOf = null;

public AlternateAccess() {
	id = identifier;
}

public AlternateAccess(byte[] code) {
	id = identifier;
	this.code = code;
}

public AlternateAccess(List<SubChoice> seqOf) {
	id = identifier;
	this.seqOf = seqOf;
}

public int encode(BerByteArrayOutputStream berOStream, boolean explicit) throws IOException {
	int codeLength;

	if (code != null) {
		codeLength = code.length;
		for (int i = code.length - 1; i >= 0; i--) {
			berOStream.write(code[i]);
		}
	}
	else {
		codeLength = 0;
		for (int i = (seqOf.size() - 1); i >= 0; i--) {
			codeLength += seqOf.get(i).encode(berOStream, true);
		}

		codeLength += BerLength.encodeLength(berOStream, codeLength);

	}

	if (explicit) {
		codeLength += id.encode(berOStream);
	}

	return codeLength;
}

public int decode(InputStream iStream, boolean explicit) throws IOException {
	int codeLength = 0;
	int subCodeLength = 0;
	seqOf = new LinkedList<SubChoice>();

	if (explicit) {
		codeLength += id.decodeAndCheck(iStream);
	}

	BerLength length = new BerLength();
	codeLength += length.decode(iStream);

	while (subCodeLength < length.val) {
		SubChoice element = new SubChoice();
		subCodeLength += element.decode(iStream, null);
		seqOf.add(element);
	}
	if (subCodeLength != length.val) {
		throw new IOException("Decoded SequenceOf or SetOf has wrong length tag");

	}
	codeLength += subCodeLength;

	return codeLength;
}
public void encodeAndSave(int encodingSizeGuess) throws IOException {
	BerByteArrayOutputStream berOStream = new BerByteArrayOutputStream(encodingSizeGuess);
	encode(berOStream, false);
	code = berOStream.getArray();
}
}

