package org.openiec61850.scsm.mms;

import org.junit.Assert;
import org.junit.Test;

public class MMSConverterTest {

	@Test
	public void testMMSConvert() {
		float fromFloat = -123.321f;
		byte[] rawData = MmsAsn1PrimitiveTypeConverter.toByteArray(fromFloat);
		Assert.assertEquals(5, rawData.length);

		double fromDouble = -123.321;
		rawData = MmsAsn1PrimitiveTypeConverter.toByteArray(fromDouble);
		Assert.assertEquals(9, rawData.length);

		byte fromByte = (byte) -12;
		rawData = MmsAsn1PrimitiveTypeConverter.toByteArray(fromByte);
		Assert.assertEquals(1, rawData.length);

		short fromShort = -123;
		rawData = MmsAsn1PrimitiveTypeConverter.toByteArray(fromShort);
		Assert.assertEquals(2, rawData.length);

		long fromLong = -123456789;
		rawData = MmsAsn1PrimitiveTypeConverter.toByteArray(fromLong);
		Assert.assertEquals(8, rawData.length);
		Assert.assertEquals(fromLong, MmsAsn1PrimitiveTypeConverter.toLong(rawData));
	}
}
