package org.openiec61850.scsm.mms;

import org.junit.Assert;
import org.junit.Test;
import org.openiec61850.common.model.FunctionalConstraint;

public class MMSHelperTest {
	static String objRef = "LD1/LN1.DO1.DA1.SDA1";
	static FunctionalConstraint fc = FunctionalConstraint.SV;
	static String mmsDomainId = "LD1";
	static String mmsItemId = "LN1$SV$DO1$DA1$SDA1";

	@Test
	public void testConvertToMMSReference() {
		Assert.assertEquals(FunctionalConstraint.MX, MMSReference.getFunctionalConstraint("LN1$MX"));
	}

	@Test
	public void testConvertFromMMSReference() {
		Assert.assertEquals(fc, MMSReference.getFunctionalConstraint(mmsItemId));
		Assert.assertEquals(fc.toString(), MMSReference.getFunctionalConstraint(mmsItemId).toString());
	}

}
